module Elab.WiredIn where

import GHC.Stack.Types

import Syntax

wiType  :: WiredIn -> NFType
wiValue :: WiredIn -> NFType

iand, ior :: NFEndp -> NFEndp -> NFEndp
inot      :: NFEndp -> NFEndp
ielim     :: NFSort -> Value -> Value -> Value -> NFEndp -> Value

outS :: HasCallStack => NFSort -> NFEndp -> Value -> Value -> Value
comp :: HasCallStack => NFLine -> NFEndp -> Value -> Value -> Value
fill :: HasCallStack => NFLine -> NFEndp -> Value -> Value -> Value -> Value
hComp :: NFSort -> NFEndp -> Value -> Value -> Value

glueType :: NFSort -> NFEndp -> NFPartial -> NFPartial -> Value
glueElem :: NFSort -> NFEndp -> NFPartial -> NFPartial -> NFPartial -> Value -> Value
unglue   :: HasCallStack => NFSort -> NFEndp -> NFPartial -> NFPartial -> Value -> Value

fun :: (Value -> Value) -> Value
system :: (Value -> Value -> Value) -> Value

strictK :: NFSort -> Value -> NFSort -> Value -> Value -> Value
strictJ :: NFSort -> Value -> NFSort -> Value -> Value -> Value -> Value

projIntoCase :: (Term -> Term) -> (Term, Int, Term) -> (Term, Int, Term)